#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include <sys/stat.h>
#include <signal.h>
#include <stdlib.h>
#include <stdio.h>
#include <sys/msg.h>
#include <sys/sem.h>

#include <server.h>
#include <structures.h>
#include <custom_sem.h>
#include <custom_shm.h>
#include <errExit.h>
#include <forza4.h>


int semid;
int msgid;
int shmid;

tile_t *board;

void sigHandlerServer(int sig) {
    if (sig == SIGINT) {
        //TODO:


        // per il secondo SIGINT basta modificare il sig in SIGTERM
    }

    if (sig == SIGTERM) {
        //TODO: killare figli

        // msgq
        if (msgctl(msgid, IPC_RMID, NULL) == -1) {
            errExit("msgctl", "sigHandlerServer");
        }

        // sem
        if (semctl(semid, 0, IPC_RMID, 0) == -1) {
            errExit("semctl", "sigHandlerServer");
        }

        // shm
        if (shmdt(board) == -1) {
            errExit("shmdt", "sigHandlerServer");
        }
        if (shmctl(shmid, IPC_RMID, NULL) == -1)
            errExit("shmctl", "SigHandlerSever");
    }

    exit(0);
}


int main(int argc, char *argv[]){
    input_server_t input = check_input(argc, argv);

    // SIGNAL
    sigset_t mySet;
    sigfillset(&mySet);
    sigdelset(&mySet, SIGINT);
    sigdelset(&mySet, SIGTERM);
    sigprocmask(SIG_SETMASK, &mySet, NULL);

    if (signal(SIGINT, sigHandlerServer) == SIG_ERR) {
        errExit("signal SIGINT", "f4Server");
    }
    if (signal(SIGTERM, sigHandlerServer) == SIG_ERR) {
        errExit("signal SIGTERM", "f4Server");
    }
    //


    // MSGQ
    key_t msgKey = ftok(KEYFILE, 'M');
    msgid = msgget(msgKey, IPC_CREAT | S_IRUSR | S_IWUSR);
    if (msgid == -1){
        errExit("msgget", "F4Server");
    }
        // msg
        msg_t msg = {
            .mtype = 1,
            .server_in = input
            //.playerid = 1;
        };

        // msgsnd
        if (msgsnd(msgid, &msg, sizeof(msg_t)-sizeof(long), 0) == -1) {
            errExit("msgsnd1", "F4Server");
        }

        //msg.playerid = 2;
        if (msgsnd(msgid, &msg, sizeof(msg_t)-sizeof(long), 0) == -1) {
            errExit("msgsnd2", "F4Server");
        }

    //

    // SHM
    shmid = getShmid(input.rows, input.collums);
    board = shmServerAt(shmid);
    //

    // SEM
    key_t semKey = ftok(KEYFILE, 'S');
    semid = semget(semKey, 2, S_IRUSR | S_IWUSR | IPC_CREAT);
    if (semid == -1) {
        errExit("getsem", "F4Server");
    }
    
    resetServerSem(semid);
    //



    semOp(semid, 0, 2); // aperurta semaforo per connessione dei due client
    semOp(semid, 0, 0); // aspetto che si connettano i due client


    // faccio quello che devo fare

    int turns_left = input.rows * input.collums;
    move_t move;

    do {
        if(turns_left % 2) {        //TODO: da scegliere chi fare iniziare
            semOp(semid, 0, 1);
        }else {
            semOp(semid, 1, 1);
        }

        if (msgrcv(msgid, &move, sizeof(move_t) - sizeof(long), 2, 0) == -1) {
            errExit("msgrcv", "F4Client");
        }


    } while(--turns_left && !checkWin(board, move.move, input.rows, input.collums));


    


    return 0;
}